"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.withTimeout = void 0;
const withTimeout = (options, tests) => {
    const pactTestTimeout = options.timeout || 30000;
    let originalTimeout;
    beforeAll(() => {
        originalTimeout = global.jasmine
            ? global.jasmine.DEFAULT_TIMEOUT_INTERVAL
            : 5000;
        jest.setTimeout(pactTestTimeout);
    });
    afterAll(() => {
        jest.setTimeout(originalTimeout);
    });
    describe(`with ${pactTestTimeout} ms timeout for Pact`, () => {
        tests();
    });
};
exports.withTimeout = withTimeout;
//# sourceMappingURL=withTimeout.js.map