"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fpactWith = exports.xpactWith = exports.pactWith = exports.getProviderBaseUrl = void 0;
const pact_1 = require("@pact-foundation/pact");
const config_1 = require("./internal/config");
const withTimeout_1 = require("./internal/withTimeout");
const scaffold_1 = require("./internal/scaffold");
const setupProvider = (options) => {
    const pactMock = new pact_1.Pact(options);
    beforeAll(() => pactMock.setup());
    afterAll(() => pactMock.finalize());
    afterEach(() => pactMock.verify());
    return pactMock;
};
const getProviderBaseUrl = (provider) => provider.mockService
    ? provider.mockService.baseUrl
    : `http://${provider.opts.host}:${provider.opts.port}`;
exports.getProviderBaseUrl = getProviderBaseUrl;
const pactWithWrapper = (options, tests) => {
    (0, withTimeout_1.withTimeout)(options, () => {
        tests(setupProvider((0, config_1.applyPactOptionDefaults)(options)));
    });
};
exports.pactWith = (0, scaffold_1.extendPactWith)(pactWithWrapper);
exports.xpactWith = exports.pactWith.skip;
exports.fpactWith = exports.pactWith.only;
//# sourceMappingURL=pactWith.js.map